/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

// udpserverDlg.cpp : implementation file
//

#include "stdafx.h"
#include "udpserver.h"
#include "udpserverDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define		IDT_TIMER	1001
#define		SENDERR		0x01
#define		RECVERR		0x02
#define		DISCONN		0x04
#define		ENDTHRD		0x08

UINT	ThreadPrg(LPVOID pParam);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUdpserverDlg dialog

CUdpserverDlg::CUdpserverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUdpserverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUdpserverDlg)
	m_port = _T("4000");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_startflag = FALSE;
	m_errflag = 0;	
}

void CUdpserverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUdpserverDlg)
	DDX_Text(pDX, IDC_PORT, m_port);
	DDV_MaxChars(pDX, m_port, 4);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUdpserverDlg, CDialog)
	//{{AFX_MSG_MAP(CUdpserverDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUdpserverDlg message handlers

BOOL CUdpserverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	UpdateButton();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUdpserverDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
		if (nID == 61536) {
			m_errflag |= ENDTHRD;
			closesocket(m_sock);
			Sleep(100);
			CDialog::DestroyWindow();
		}
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUdpserverDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUdpserverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUdpserverDlg::OnOK() 
{
	// TODO: Add extra validation here
	m_startflag = TRUE;
	m_errflag = 0;
	UpdateData(TRUE);	
	if ((m_sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == INVALID_SOCKET) {
		CString	err;
        err.Format(IDS_SOCKERR,GetLastError());
        AfxMessageBox(err);		
		m_startflag = 0;
	}

	m_sockinfo.sin_family = AF_INET;
	m_sockinfo.sin_addr.S_un.S_addr	= htonl(INADDR_ANY);
	m_sockinfo.sin_port = htons((unsigned)atol(m_port));

	m_sockinfocli.sin_family = AF_INET;
	m_sockinfocli.sin_addr.S_un.S_addr	= htonl(INADDR_ANY);
	m_sockinfocli.sin_port = htons((unsigned)atol(m_port));

	if ( bind( m_sock, (struct sockaddr *)&m_sockinfo, sizeof(m_sockinfo)) == SOCKET_ERROR ) {
		CString	err;
        err.Format(IDS_BINDERR,GetLastError());
        AfxMessageBox(err);		
		m_startflag = 0;
	}
	UpdateButton();

	if (m_startflag != 0) {
		SetTimer(IDT_TIMER, 50, NULL);
		m_pthread = AfxBeginThread(ThreadPrg, this);
	}
	//CDialog::OnOK();
}

void CUdpserverDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_errflag |= ENDTHRD;
	closesocket(m_sock);
	m_startflag = 0;
	m_errflag = 0;
	UpdateButton();
	
	//CDialog::OnCancel();
}
					
void CUdpserverDlg::UpdateButton()
{
	GetDlgItem(IDOK)->EnableWindow(!m_startflag);
	GetDlgItem(IDCANCEL)->EnableWindow(m_startflag);
	GetDlgItem(IDC_PORT)->EnableWindow(!m_startflag);
}


UINT	ThreadPrg(LPVOID pParam)
{
	int		recvret;
	int		sendret;
	char	recvdata[1600];
	int		dwSenderSize;

	CUdpserverDlg	*pDlg = (CUdpserverDlg *)pParam;
	dwSenderSize = sizeof(pDlg->m_sockinfocli);
	while (1) {
		if (pDlg->m_errflag & ENDTHRD)
			break;
		if ((recvret = recvfrom(pDlg->m_sock, recvdata, 1600, 0, (struct sockaddr *)&(pDlg->m_sockinfocli), &dwSenderSize)) == SOCKET_ERROR) {
			pDlg->m_recverr = GetLastError();
			pDlg->m_errflag |= RECVERR;
			return	TRUE;		
		}
		if (recvret > 0) {
			if ((sendret = sendto(pDlg->m_sock, recvdata, recvret, 0, (struct sockaddr *)&(pDlg->m_sockinfocli), sizeof(pDlg->m_sockinfocli))) == SOCKET_ERROR) {
				pDlg->m_recverr = GetLastError();
				pDlg->m_errflag |= SENDERR;
				return	TRUE;
			}
		}
		if (recvret == 0)
			pDlg->m_errflag |= DISCONN;	
	}

	return	TRUE;
}

void CUdpserverDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == IDT_TIMER) {
		if (m_errflag & DISCONN) {
			CString	err;
			KillTimer(IDT_TIMER);
			err.LoadString(IDS_DISCONN);
			m_startflag = 0;
			OnCancel();
			AfxMessageBox(err);	
		} else if (m_errflag & SENDERR) {
			CString	err;
			KillTimer(IDT_TIMER);
			err.Format(IDS_SENDDATAERR,m_senderr);
			m_startflag = 0;
			OnCancel();
			AfxMessageBox(err);	
		} else if (m_errflag & RECVERR) {
			CString	err;
			KillTimer(IDT_TIMER);
			err.Format(IDS_RECVDATAERR,m_recverr);
			m_startflag = 0;
			OnCancel();
			AfxMessageBox(err);	
		}
	}
	
	CDialog::OnTimer(nIDEvent);
}
