# Defined for UC-7420/7410/7408/7402-LX/DA-660-8/16-LX
#PLATFORM = UC7400_AND_DA660

# Defined for UC-7420/7410/7408/7402-LX Plus and /DA-661/662/663-16-LX
#PLATFORM = UC7400PLUS_AND_DA66X

# Defined for UC-8410/8416/8418-LX
#PLATFORM = UC8400

# Defined for W406/W416-LX, IA260/261/262-LX, EM-2260-LX
# PLATFORM = W4X6_IA26X

# Defined for DA-681/682-LX, DA-710, V2100
  PLATFORM = DA680


ifeq ($(PLATFORM), UC7400_AND_DA660)
  PREFIX=mxscaleb-
  MOXALIB_INSTALL_DIR=/usr/local/mxscaleb/armv5b-linux/lib/
  MOXALIB_SOURCE=dio.c swtd.c keypad.c lcm.c
  MOXALIB_OBJ=dio.o swtd.o keypad.o lcm.o
  WATCHDOG_LDFLAGS=-lmoxalib
else 
ifeq ($(PLATFORM),UC7400PLUS_AND_DA66X)
  PREFIX=xscale_be-
  MOXALIB_INSTALL_DIR=/usr/local/xscale_be/target/usr/lib/
  MOXALIB_SOURCE=dio.c swtd.c keypad.c lcm.c
  MOXALIB_OBJ=dio.o swtd.o keypad.o lcm.o
  WATCHDOG_LDFLAGS=-lmoxalib
else
ifeq ($(PLATFORM),UC8400)
  PREFIX=xscale-linux-
  MOXALIB_INSTALL_DIR=/usr/local/arm-linux/arm-linux/lib/be
  MOXALIB_SOURCE=dio.c swtd.c
  MOXALIB_OBJ=dio.o swtd.o
  WATCHDOG_LDFLAGS=-lmoxalib
else
ifeq ($(PLATFORM),W4X6_IA26X)
  PREFIX=arm-linux-
  MOXALIB_INSTALL_DIR=/usr/local/arm-linux/arm-linux/lib/
  MOXALIB_SOURCE=dio.c swtd.c gpio.c keypad.c lcm.c
  MOXALIB_OBJ=dio.o swtd.o gpio.o keypad.o lcm.o
  WATCHDOG_LDFLAGS=-lmoxalib
else #x86
  PREFIX=
  MOXALIB_INSTALL_DIR=
  MOXALIB_SOURCE=swtd.c
  MOXALIB_OBJ=swtd.o 
  WATCHDOG_LDFLAGS=libswtd.c
  WATCHDOG_CFLAGS=-DNO_MOXADEVICE_HEADER 
endif
endif
endif
endif  


