/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

#include <stdio.h>
#include <string.h>
#include "serial.h"

#define SPEED	9600

int port= PORT1;

void WriteSerial( char* data)
{
	char* str;
	char buf[ 1024];
	int i, buf_count= 0;

	if( strlen( data) == 0)
		return;

	str= strstr( data, "writedata");
	str+= 10;	// strlen of "writedata="
	while( *str != '&')
	{
		buf[ buf_count++]= *str;
		str++;
	}
	buf[ buf_count]= 0;

	SerialWrite( port, buf, strlen( buf));
}

int main( int argc, char* argv[])
{
	char readdata[ 1024], writedata[ 1024];
	char* ptr;

	printf("Content-Type:text/html;charset=iso-8859-1\n\n");
	printf("<TITLE>Serial read/write example</TITLE>\n");
	printf("<H3>Serial read/write example</H3>\n");

	SerialOpen( port);
	SerialSetSpeed( port, SPEED);
	SerialSetParam( port, 0, 8, 1);

	if( argc == 2)
		WriteSerial( argv[ 1]);
	if( (char*)getenv("QUERY_STRING") != NULL)
		WriteSerial( (char*)getenv("QUERY_STRING"));
/*
	strcpy( writedata, getenv("QUERY_STRING"));
	WriteSerial( writedata);
*/
	sleep(1);
	SerialNonBlockRead( port, readdata, 1024);
	printf("<form action=serialform.cgi method=get>");
	printf("<table>");

	printf("<tr><td>Read from serial port1</td><td><input type=textarea name=readdata value=\"%s\" disabled></td></tr>", readdata);
	printf("<tr><td>Write to serial port1</td><td><input type=textarea name=writedata></td></tr>");
	printf("<tr><td colspans=2><input type=submit name=Submit<td></tr>\n");

	printf("</table>\n");
	printf("</form>");

	return 0;
}

