/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

/******************************************************************************
File Name : watchdog.c

Description :
	The program enable the watch dog timer for 5 seconds and do not ack 
	the watch dog timer in 5 seconds. It will cause the system to reboot.

Usage :
	1.Compile this file and execute on UC7000 series.
	2.Run the program

History :
	Versoin		Author		Date		Comment
	1.0		Jared		07-06-2005	Wrote it
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/time.h>
#include <pthread.h>
#ifndef NO_MOXADEVICE_HEADER
#include <moxadevice.h>
#endif
int swtdfd, fdRTC;
int abc;
pthread_once_t  once=PTHREAD_ONCE_INIT;

void initvar(void)
{
	abc = 0;
	swtdfd = swtd_open();
	printf("swtdfd1 = %d\n", swtdfd);
	
	if (swtdfd < 0) {
	printf("Open sWatchDog device fail !\n");
	exit(1);
	}
	swtd_enable(swtdfd, 5000); // enable it and set it 5 seconds
	printf("swtdfd2 = %d\n", swtdfd);
}

void onesec(int signo)
{
	if(++abc < 10)
		swtd_ack(swtdfd);
	printf("swtdfd3 = %d, abc = %d\n", swtdfd, abc);
}

void *ssend(void *ptr)
{
	struct sigaction act;
	struct itimerval value;
	
	act.sa_handler = onesec;
	act.sa_flags = 0;
	sigemptyset(&act.sa_mask);

	sigaction(SIGVTALRM, &act, NULL);
	
	value.it_value.tv_sec = 2;
	value.it_value.tv_usec = 0;
	value.it_interval = value.it_value;
	setitimer(ITIMER_VIRTUAL, &value, NULL);


	while(1);
}

main()
{
	pthread_t	send;
	
 	pthread_once(&once, initvar);

	pthread_create(&send,NULL,ssend,NULL);
	while(1);
}

